--Slash Commands
SLASH_RELOADUI = "/rl"
SlashCmdList.RELOADUI = ReloadUI

SLASH_FRAMESTK1 = "/fs"
SlashCmdList.FRAMESTK = function()
	LoadAddOn('Blizzard_DebugTools')
	FrameStackTooltip_Toggle()
end

for i = 1, NUM_CHAT_WINDOWS do
	_G["ChatFrame"..i.."EditBox"]:SetAltArrowKeyMode(false)
end

SLASH_DEATHROLL1, SLASH_DEATHROLL2 = "/dr", "/deathroll";
local function handler(msg, editbox)
	if msg == "" then
		if (IsInGuild()==true or IsInRaid()==true or IsInGroup()==true) then
			local frame = getglobal("Death_Roll_Frame")
			if(frame and frame:IsVisible()) then
				frame:Hide()
			else
				frame:Show()
			end
		else 
			print("Player must be in a guild or group to play")
		end
	end
end
SlashCmdList["DEATHROLL"] = handler;

------------------------------------------------------------------------------------

--Core game code

--Main frame for addon
local UIConfig = CreateFrame("Frame", "Death_Roll_Frame", UIParent, "BasicFrameTemplateWithInset");
UIConfig:SetSize(200,250)
UIConfig:SetPoint("CENTER", UIParent, "CENTER")
UIConfig:SetMovable(true)
UIConfig:EnableMouse(true)
UIConfig:RegisterForDrag("LeftButton")
UIConfig:SetScript("OnDragStart", UIConfig.StartMoving)
UIConfig:SetScript("OnDragStop", UIConfig.StopMovingOrSizing)
UIConfig:Hide()

--Extra frames inside main frame
UIConfig.title = UIConfig:CreateFontString("DeathRoll", "OVERLAY");
UIConfig.title:SetFontObject("GameFontNormal");
UIConfig.title:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, 0);
UIConfig.title:SetText("Death Roll");

--Buttons
--Roll
UIConfig.showButton = CreateFrame("Button", "MyButton", UIConfig, "GameMenuButtonTemplate");
UIConfig.showButton:SetPoint("CENTER", UIConfig, "TOP", -47, -43);
UIConfig.showButton:SetSize(90, 30);
UIConfig.showButton:SetText("Roll");
UIConfig.showButton:SetNormalFontObject("GameFontNormalLarge");
UIConfig.showButton:SetHighlightFontObject("GameFontHighlightLarge");

--Restart
UIConfig.delButton = CreateFrame("Button", "MyDelButton", UIConfig, "GameMenuButtonTemplate");
UIConfig.delButton:SetPoint("CENTER", UIConfig, "TOP", 45, -43);
UIConfig.delButton:SetSize(90, 30);
UIConfig.delButton:SetText("Restart");
UIConfig.delButton:SetNormalFontObject("GameFontNormalLarge");
UIConfig.delButton:SetHighlightFontObject("GameFontHighlightLarge");
UIConfig.delButton:Disable()

--Extra frame for showing result with Scroll frame
messageframe = CreateFrame("ScrollingMessageFrame", "MyScrollFrame", UIConfig)
messageframe:SetFontObject("GameFontHighlight")
messageframe:SetPoint("CENTER", UIConfig, "CENTER", 0, -30)
messageframe:SetSize((UIConfig:GetWidth()-20), (UIConfig:GetHeight()-70))
messageframe:SetMaxLines(15)
messageframe:SetInsertMode("TOP")
messageframe:SetJustifyH("LEFT")
messageframe:SetFading(false)
UIParent.messageframe=messageframe

--Event handlers to run after creating frames
UIConfig:SetScript("OnHide", function() messageframe:Clear() end)

-----------------------------------------------------------------------
--Variables
local upperLimit = 100 --9999
local lowerLimit = 1
local temp = upperLimit
local textToShow = ""
local prefixText = "text_deathroll"
local prefixTemp = "temp_deathroll"
local prefixReset = "reset_deathroll"

--display the upper limit of the rolls in the title bar
UIConfig.title:SetText("Roll start: "..upperLimit);

--Core Function
local function roll(upNum)
	temp = math.random(1, upNum)
	if temp == lowerLimit then
		return " has lost the game!\n" .. UnitName("player") .. " rolls " .. tostring(temp)
	else
		return " rolls " .. tostring(temp)
	end
end

--Sending Functions
UIConfig.showButton:SetScript("OnClick", function(self)
	textToShow = tostring(roll(temp));
	if (IsInRaid()) then
		C_ChatInfo.SendAddonMessage(prefixText, textToShow, "RAID")
		C_ChatInfo.SendAddonMessage(prefixTemp, tostring(temp), "RAID")
  elseif (IsInGroup()) then
    C_ChatInfo.SendAddonMessage(prefixText, textToShow, "PARTY")
		C_ChatInfo.SendAddonMessage(prefixTemp, tostring(temp), "PARTY")
	elseif (IsInGuild()) then
		C_ChatInfo.SendAddonMessage(prefixText, textToShow, "GUILD")
		C_ChatInfo.SendAddonMessage(prefixTemp, tostring(temp), "GUILD")
	else
		messageframe:AddMessage(UnitName("player") .. textToShow)
	end
end);

UIConfig.delButton:SetScript("OnClick", function(self)
	C_ChatInfo.SendAddonMessage(prefixReset, "Resetting", "RAID")
	if (IsInRaid()) then
		C_ChatInfo.SendAddonMessage(prefixReset, "Resetting", "RAID")
	elseif (IsInGroup()) then
		C_ChatInfo.SendAddonMessage(prefixReset, "Resetting", "PARTY")
	elseif (IsInGuild()) then
		C_ChatInfo.SendAddonMessage(prefixReset, "Resetting", "GUILD")
	else
		messageframe:Clear()
		UIConfig.showButton:Enable()
		temp = upperLimit
		UIConfig.delButton:Disable()
	end
end)


--Receiving Functions
local succesText = C_ChatInfo.RegisterAddonMessagePrefix(prefixText)
local succesTemp = C_ChatInfo.RegisterAddonMessagePrefix(prefixTemp)
local succesReset = C_ChatInfo.RegisterAddonMessagePrefix(prefixReset)
UIConfig:RegisterEvent("CHAT_MSG_ADDON")
UIConfig:SetScript("OnEvent", function(self, event, prefix, message, channel, sender)
	
	--Getting player name from sender
	playerName,_ = strsplit(" %- ", sender)
	
	--show the message
	if (succesText == true) then
		if event == "CHAT_MSG_ADDON" then
			if prefix == prefixText then
				messageframe:AddMessage(playerName .. message)
			end
		end
	end
	
	--Store given tempNumber in your own temp
	if (succesTemp == true) then
		if event == "CHAT_MSG_ADDON" then
			if prefix == prefixTemp then
				temp = tonumber(message)
				UIConfig.title:SetText("Last roll: "..temp);
			end
		end
	end
	
	--Reset
	if (succesReset == true) then
		if event == "CHAT_MSG_ADDON" then
			if prefix == prefixReset then
				messageframe:Clear()
				UIConfig.showButton:Enable()
				temp = upperLimit
				UIConfig.title:SetText("Roll start: "..upperLimit);
				UIConfig.delButton:Disable()
			end
		end
	end
	
	--Button Switching
	if temp==lowerLimit then
		UIConfig.showButton:Disable()
		UIConfig.delButton:Enable()
	end
end)
